'use strict';

const api = {
    dgram: require('dgram'),
    cp: require('child_process'),
    fs: require('fs'),
};


const logeble = fn => (...args) => {
    fn(args);
//    console.log('log: ' + args);
};



const runFramework = port => {
    const defaultFramework = './node_modules/antihype/udpclient';
    api.fs.readFile('./fw.json', (err, data) => {
        if (err) {
            console.log('./fw.json error.');
            api.fs.writeFile('./fw.json', JSON.stringify({ path: defaultFramework }), (err) => {
                if (err) console.log('./fw.json creating error.');
                else console.log('./fw.json created.');
                api.cp.spawn(defaultFramework, [port], {
                    detached: true,
                    stdio: [process.stdin, process.stdout, process.stderr],
                });
            });
        } else {
            const path = JSON.parse(data).path;
            if (path) {
                console.log('framework is ready to start.');
                console.log({ path, port });
                api.cp.spawn(path, [port], {
                    detached: true,
                    stdio: [process.stdin, process.stdout, process.stderr],
                });
            } else {
                console.log('error: plase enter correct path.');
            }
        }
    });
};

const createLinker = (port, listener) => {
    const host = 'localhost';
    const server = api.dgram.createSocket('udp4');

    const send = logeble(message => server.send(message, port + 1, host));
    server.on('message', listener.bind(null, send));
    server.on('error', console.log);
    server.on('close', console.log);

    server.bind(port);
    runFramework(port);
    return { port, send };
};

module.exports = { createLinker };
